unit DiggerWin32Impl;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DiggerComponent, Menus;

type
  TfrmDigger = class(TForm)
    DiggerPanel1: TDiggerPanel;
    MainMenu1: TMainMenu;
    Game1: TMenuItem;
    miExit: TMenuItem;
    N1: TMenuItem;
    miMagnify: TMenuItem;
    miStart: TMenuItem;
    miPause: TMenuItem;
    miReset: TMenuItem;
    N2: TMenuItem;
    procedure miMagnifyClick(Sender: TObject);
    procedure miExitClick(Sender: TObject);
    procedure miStartClick(Sender: TObject);
    procedure miPauseClick(Sender: TObject);
    procedure miResetClick(Sender: TObject);
  private
    { Private declarations }
    procedure TrapException(Sender: TObject; E: Exception);
  public
    { Public declarations }
  end;

var
  frmDigger: TfrmDigger;

implementation

{$R *.dfm}

procedure TfrmDigger.miMagnifyClick(Sender: TObject);
begin
  if miMagnify.Checked then
    DiggerPanel1.Magnification := 2 else
    DiggerPanel1.Magnification := 1;
end;

procedure TfrmDigger.miExitClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmDigger.TrapException(Sender: TObject; E: Exception);
var
  I: Integer;
  F: TextFile;
begin
{$I-}
  AssignFile(F, 'C:\EXCEPTION.TXT');
  Rewrite(F);
  for I := Low(GKeys) to High(GKeys) do
    WriteLn(F, GKeys[I]);
  CloseFile(F);
{$I+}  
end;

procedure TfrmDigger.miStartClick(Sender: TObject);
begin
  // miMagnify.Enabled := False;
  Application.OnException := TrapException;
  DiggerPanel1.Start;
end;

procedure TfrmDigger.miPauseClick(Sender: TObject);
begin
  DiggerPanel1.Pause;
end;

procedure TfrmDigger.miResetClick(Sender: TObject);
begin
  DiggerPanel1.Restart;
end;

end.
